module Docs
  class Pytorch
    class EntriesFilter < Docs::EntriesFilter

      def get_name
        return slug 
      end

      def get_type
        if slug.start_with?('notes')
          type = 'notes'
        else
          type = slug
        end
        return type
      end

      def additional_entries
        # this css works well in light theme, but in dark theme looks bad. so, I disable it
        # _css = "border-color:#94bbeb; border:1px solid #d8d8d8; background:#d4f3fd; display: block; line-height=1.375rem; margin: 2em 0 1em; padding-left: .5em; padding-right: .5m;"

        # if slug.start_with?('notes')
        #   return [[slug.gsub(/^notes./, ""), nil, 'notes']]
        # end
        entries = []
        
        # add class
        # example: torch.nn.Module
        css('dl.class').each do |node|
          _class = node.at_css('> dt')
          # this css looks bad in dark theme
          # _class['style'] = _css
          _id = _class['id']
          _type = slug
          if slug == 'torch'
            _name = 'torch'
          else
            _name = _id.gsub(/^torch\./, "") 
          end
          entries << [_name, _id, _type]

          # add method
          # example: torch.nn.Module.add_module
          node.css('dl.method > dt').each do |method_|
            _method_id = method_['id']  
            _method_type = slug

            _name = _method_id.gsub(/^torch\./, "") 
            _id = _method_id
            _type = _method_type
            entries << [_name, _id, _type]
          end
        end

        # add function
        # example: torch.nn.utils.clip_grad_norm
        css('dl.function > dt').each do |node|
          # this css looks bad in dark theme
          # node['style'] = _css
          # _id = node['id'] # some function does not has id
          _id = node.at_css('code.descclassname').content + node.at_css('code.descname').content
          if slug == "torch"
            _name = _id
          else
            _name = _id.gsub(/^torch\./, "")
          end
          _type = slug
          entries << [_name, _id, _type]
        end
        entries
      end
    end
  end
end