module Docs
  class Pytorch < UrlScraper
    self.name = 'Pytorch'
    self.type = 'sphinx'
    self.links = {
        home: 'http://pytorch.org',
        code: 'https://github.com/pytorch/pytorch'
    }

    html_filters.push 'pytorch/entries', 'pytorch/clean_html', 'sphinx/clean_html'

    # ignore sidebar etc, only keep main document
    options[:container] = '.document'

    options[:skip] = %w(py-modindex.html genindex.html)
    # options[:skip_patterns] = [/torchvision/, /_modules/]
    options[:skip_patterns] = [/_modules/]

    options[:attribution] = <<-HTML
      &copy; Copyright 2017, Torch Contributions.
    HTML

    version '0.3.0' do
      self.release = '0.3.0'
      self.base_url = "http://pytorch.org/docs/#{self.release}/"
    end
    version '0.2.0' do
      self.release = '0.2.0'
      self.base_url = "http://pytorch.org/docs/#{self.release}/"
    end
    version '0.1.12' do
      self.release = '0.1.12'
      self.base_url = "http://pytorch.org/docs/#{self.release}/"
    end
  end
end